unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, jpeg, math, ComCtrls, unit4;

const
  GX = 100; //                                                         // 8 7 6
  GY = 20;                                                                                                                    // 1 0 5
  sos8:array[0..7] of tpoint=((X:-1;Y:0),(X:-1;Y:+1),(X:0;Y:+1),(X:+1;Y:+1),(X:+1;Y:0),(X:+1;Y:-1),(X:0;Y:-1),(X:-1;Y:-1));   // 2 3 4

type
  TForm1 = class(TForm)
    Button1: TButton;
    OpenDialog1: TOpenDialog;
    ProgressBar1: TProgressBar;
    Button2: TButton;
    Button3: TButton;
    procedure Button1Click(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    procedure OpenPic(FileName:string);
    procedure Opoznat;
  end;

  trgb = record
   B,G,R: byte;
  end;
  ARGB = array [0..0] of TRGB;
  PARGB = ^ARGB;

  dex = record
   dX, dY:extended;
  end;

  ZonaRosta = array of integer;
  PZR = ^ZonaRosta;

  item = record
   N:integer; // ,    /          
   mas: array of tpoint; //  
   Y:integer; // Y  () ,     /
   Re:integer; //   ,     N=0
  end;

  co = record
   ug:extended;
   N:integer;
  end;

  vektor = record
   ug,D:extended;
  end;

  expoint = record
   X,Y:extended;
  end;

var
  Form1: TForm1;
  sour,buf:tbitmap;
  ps:array of PARGB;
  trig:boolean;
  vec1:array of byte;
  globalX,globalY,prevx,prevy:integer;
  Obj:array of item; //  (        0)
  drawtrig: boolean=false;
  prevdx, prevdy: integer; //      

implementation

{$R *.dfm}

procedure TForm1.OpenPic(FileName:string);
 var ext:string;
 i:integer;
 MyJPEG: TJPEGImage;
begin
 ext:=ExtractFileExt(FileName);
 ext:=LowerCase(ext);
 sour.Width:=0;
 if ext='.bmp' then begin
  sour.LoadFromFile(FileName);
 end else begin // 
  MyJPEG := TJPEGImage.Create;
  try
   MyJPEG.LoadFromFile(FileName);
   sour.Width:=MyJPEG.Width;
   sour.Height:=MyJPEG.Height;
   sour.Canvas.Draw(0,0,MyJPEG);
  finally
   MyJPEG.Free;
  end;
 end;
 sour.PixelFormat:=pf24bit;
 sour.Width:=sour.Width+2;    //   ,     
 sour.Height:=sour.Height+2;
 bitblt(sour.Canvas.Handle,1,1,sour.Width-2,sour.Height-2,sour.Canvas.Handle,0,0,SRCCOPY);
 PS:=nil;
 setlength(PS,sour.Height);
 for i:=0 to High(PS) do PS[i]:=sour.scanline[i];
 buf.Width:=sour.Width;
 buf.Height:=sour.Height;
end;

procedure GetObjects;
 var i,j,K,N,l,hiY,hiG,z,t:integer;
 ZR1,ZR2,sob:ZonaRosta;
 PZR1,PZR2:PZR;
 trig,find,ob,sov:boolean;
begin
 setlength(ZR1,sour.Width+2); //    
 setlength(ZR2,sour.Width+2);
 trig:=true;
 PZR1:=@ZR1; //, 
 PZR2:=@ZR2; //,   
 N:=0;
 setlength(obj,1);//    - 0,         

 find:=false; //     
 for i:=0 to sour.Height-1 do begin //  ,   
  for t:=0 to sour.Width-1 do begin //    

   if find=false then begin //    ,  
    if PS[i,t].r<128 then begin
     N:=t; // 
     if (t=sour.Width-1) then begin // ,          
      if (PZR2^[t]=0)and(PZR2^[t+1]=0) then begin //   ,     
       hiG:=length(obj); //  -   ,  
       setlength(obj,hiG+1); //    
       obj[hiG].N:=1;
       obj[hiG].Y:=i; //  
       setlength(obj[hiG].mas,1);
       obj[hiG].mas[0].Y:=i;
       obj[hiG].mas[0].X:=t;
      end else begin  //    (      2  ) - 
       if PZR2^[t]<>0 then hiG:=PZR2^[t] else hiG:=PZR2^[t+1];
       inc(obj[hiG].N);
       setlength(obj[hiG].mas,length(obj[hiG].mas)+1);
       obj[hiG].mas[high(obj[hiG].mas)].Y:=i;
       obj[hiG].mas[high(obj[hiG].mas)].X:=t;
      end;
      PZR1^[t+1]:=hiG;
      find:=false;
     end else find:=true;;
    end;
   end else begin //      
    if (PS[i,t].r>=128{  })or(t=sour.Width-1) then begin //  =j-1      
     if (t=sour.Width-1) and (PS[i,t].r<128) then j:=t+1 else j:=t; //   
     find:=false;
     sob:=nil; //     
     ob:=false; //     .      
     hiY:=10000000;  //     
     hiG:=0;
     for k:=N to j+1 do begin //  ,         ( ) (k:=N+1 to j)- 
      if ob=false then begin
       if PZR2^[k]<>0 then begin  //   ,    
        ob:=true;
        if obj[PZR2^[k]].N=0 then z:=obj[PZR2^[k]].Re  //       z
         else z:=PZR2^[k];  //   ,  
        sov:=true;
        for l:=0 to high(sob) do if sob[l]=z then begin sov:=false; break; end; //      
        if sov then begin //         
         if obj[z].Y<hiY then begin
          hiY:=obj[z].Y;
          hiG:=z; //     (     ,   )
         end;
         setlength(sob,length(sob)+1);
         sob[high(sob)]:=z;
        end;
       end;
      end else if PZR2^[k]=0 then ob:=false; //  ,    
     end;

     if sob=nil then begin //       -   !
      hiG:=length(obj); //  -   ,  
      setlength(obj,hiG+1); //    
      obj[hiG].N:=j-N;
      obj[hiG].Y:=i; //  
      setlength(obj[hiG].mas,j-N);
      for l:=N to j-1 do begin
       obj[hiG].mas[l-N].Y:=i;
       obj[hiG].mas[l-N].X:=l;
      end;
     end else begin     //     
      setlength(obj[hiG].mas,length(obj[hiG].mas)+j-N);  //      
      for l:=N to j-1 do begin
       obj[hiG].mas[high(obj[hiG].mas)-l+N].X:=l;
       obj[hiG].mas[high(obj[hiG].mas)-l+N].Y:=i;
      end;
      obj[hiG].N:=obj[hiG].N+j-N; // 

      for l:=0 to high(sob) do   //   
       if sob[l]<>hiG then begin
        obj[hiG].N:=obj[hiG].N+obj[sob[l]].N;
        setlength(obj[hiG].mas,length(obj[hiG].mas)+obj[sob[l]].N);
        for k:=0 to obj[sob[l]].N-1 do obj[hiG].mas[high(obj[hiG].mas)-k]:=obj[sob[l]].mas[k];
        obj[sob[l]].N:=0;
        obj[sob[l]].Re:=hiG;
        obj[sob[l]].mas:=nil;
       end;
     end;
     for l:=N+1 to j do PZR1^[l]:=hiG; //     
    end;
   end;
  end;
  trig:=not(trig); //      
  if trig then begin
   PZR1:=@ZR1;
   PZR2:=@ZR2;
  end else begin
   PZR1:=@ZR2;
   PZR2:=@ZR1;
  end;
  for l:=0 to high(zr1) do pzr1^[l]:=0;
 end;
end;

function Doedin(x:extended):integer; //,  
begin
 if trunc(frac(x)*10)>4 then result:=trunc(x)+1 else result:=trunc(x);
end;

function Point2Ang(x,y,CentrX,CentrY,R:extended):extended; // -    Y    12:00    0-360
 var dx,dy:extended;
begin
 if R<>0 then begin
  dx:=x-CentrX;
  dy:=y-CentrY;
  if dx<0 then
   if dy<0 then result:=360+180*arcsin(dx/R)/pi
           else result:=180-180*arcsin(dx/R)/pi
  else
   if dy<0 then result:=180*arcsin(dx/R)/pi
           else result:=180-180*arcsin(dx/R)/pi;
 end else result:=0;
end;

function Ang2Point(angle,R:extended):dex;// 0-360,   12:00   ,  -      R   (0,0)
 var z:integer;
begin
 z:=trunc(angle/180);
 case z of
 0:begin
   result.dX:=r*sin(pi*angle/180);
   result.dY:=r*-cos(pi*angle/180);
  end;
 1:begin
   angle:=angle-180*z;
   result.dX:=r*-sin(pi*angle/180);
   result.dY:=r*cos(pi*angle/180);
  end;
 end;
end;

function NextVeks(y1,x1,y2,x2,ix:integer):integer;
 var dx,dy:integer;
begin
 dx:=x2-x1;
 dy:=y2-y1;
 if (dx=-1)and(dy=0) then begin  // 1
  case ix of
   1:begin setlength(vec1,length(vec1)+1); vec1[high(vec1)]:=1; end;
   3:begin setlength(vec1,length(vec1)+3); vec1[high(vec1)-2]:=3; vec1[high(vec1)-1]:=4; vec1[high(vec1)]:=1; end;
   4:begin setlength(vec1,length(vec1)+2); vec1[high(vec1)-1]:=4; vec1[high(vec1)]:=1; end;
  end;
  result:=1;
 end else if (dx=-1)and(dy=1) then begin  // 2
  case ix of
   1:begin setlength(vec1,length(vec1)+2); vec1[high(vec1)-1]:=1; vec1[high(vec1)]:=2; end;
   2:begin setlength(vec1,length(vec1)+1); vec1[high(vec1)]:=2; end;
   3:begin setlength(vec1,length(vec1)+4); vec1[high(vec1)-3]:=3; vec1[high(vec1)-2]:=4; vec1[high(vec1)-1]:=1; vec1[high(vec1)]:=2; end;
   4:begin setlength(vec1,length(vec1)+3); vec1[high(vec1)-2]:=4; vec1[high(vec1)-1]:=1; vec1[high(vec1)]:=2; end;
  end;
  result:=1;
 end else if (dx=0)and(dy=1) then begin   // 3
  case ix of
   1:begin setlength(vec1,length(vec1)+2); vec1[high(vec1)-1]:=1; vec1[high(vec1)]:=2; end;
   2:begin setlength(vec1,length(vec1)+1); vec1[high(vec1)]:=2; end;
   4:begin setlength(vec1,length(vec1)+3); vec1[high(vec1)-2]:=4; vec1[high(vec1)-1]:=1; vec1[high(vec1)]:=2; end;
  end;
  result:=2;
 end else if (dx=1)and(dy=1) then begin   // 4
  case ix of
   1:begin setlength(vec1,length(vec1)+3); vec1[high(vec1)-2]:=1; vec1[high(vec1)-1]:=2; vec1[high(vec1)]:=3; end;
   2:begin setlength(vec1,length(vec1)+2); vec1[high(vec1)-1]:=2; vec1[high(vec1)]:=3; end;
   3:begin setlength(vec1,length(vec1)+1); vec1[high(vec1)]:=3; end;
   4:begin setlength(vec1,length(vec1)+4); vec1[high(vec1)-3]:=4; vec1[high(vec1)-2]:=1; vec1[high(vec1)-1]:=2; vec1[high(vec1)]:=3; end;
  end;
  result:=2;
 end else if (dx=1)and(dy=0) then begin   // 5
  case ix of
   1:begin setlength(vec1,length(vec1)+3); vec1[high(vec1)-2]:=1; vec1[high(vec1)-1]:=2; vec1[high(vec1)]:=3; end;
   2:begin setlength(vec1,length(vec1)+2); vec1[high(vec1)-1]:=2; vec1[high(vec1)]:=3; end;
   3:begin setlength(vec1,length(vec1)+1); vec1[high(vec1)]:=3; end;
  end;
  result:=3;
 end else if (dx=1)and(dy=-1) then begin  // 6
  case ix of
   1:begin setlength(vec1,length(vec1)+4); vec1[high(vec1)-3]:=1; vec1[high(vec1)-2]:=2; vec1[high(vec1)-1]:=3; vec1[high(vec1)]:=4; end;
   2:begin setlength(vec1,length(vec1)+3); vec1[high(vec1)-2]:=2; vec1[high(vec1)-1]:=3; vec1[high(vec1)]:=4; end;
   3:begin setlength(vec1,length(vec1)+2); vec1[high(vec1)-1]:=3; vec1[high(vec1)]:=4; end;
   4:begin setlength(vec1,length(vec1)+1); vec1[high(vec1)]:=4; end;
  end;
  result:=3;
 end else if (dx=0)and(dy=-1) then begin  // 7
  case ix of
   2:begin setlength(vec1,length(vec1)+3); vec1[high(vec1)-2]:=2; vec1[high(vec1)-1]:=3; vec1[high(vec1)]:=4; end;
   3:begin setlength(vec1,length(vec1)+2); vec1[high(vec1)-1]:=3; vec1[high(vec1)]:=4; end;
   4:begin setlength(vec1,length(vec1)+1); vec1[high(vec1)]:=4; end;
  end;
  result:=4;
 end else begin                           // 8  (dx=-1)and(dy=-1)
  case ix of
   1:begin setlength(vec1,length(vec1)+1); vec1[high(vec1)]:=1; end;
   2:begin setlength(vec1,length(vec1)+4); vec1[high(vec1)-3]:=2; vec1[high(vec1)-2]:=3; vec1[high(vec1)-1]:=4; vec1[high(vec1)]:=1; end;
   3:begin setlength(vec1,length(vec1)+3); vec1[high(vec1)-2]:=3; vec1[high(vec1)-1]:=4; vec1[high(vec1)]:=1; end;
   4:begin setlength(vec1,length(vec1)+2); vec1[high(vec1)-1]:=4; vec1[high(vec1)]:=1; end;
  end;
  result:=4;
 end;
end;

procedure TForm1.Opoznat;
 var i,j,N,k,c,prevX,prevY,curX,curY,ix,dx,dy,best,l,p,u,bestugol:integer;
 dug,min,d,ex,ey,nx,ny,minX,minY,dlina,DV,DP,ddx,ddy,DYN,DXL,DXR:extended;
 de:dex;
 resu:array of tpoint;
 vec:array of vektor;
 media:array of expoint; //     / 
 test:array [0..49] of expoint; //         
 s,s1:string;
begin
 GetObjects;  //     

 k:=0;  // 
 for i:=1 to high(obj) do if obj[i].N<>0 then inc(k);
 ProgressBar1.Max:=K;

 curX:=0;  //   ,    
 curY:=0;
 for i:=1 to high(obj) do if obj[i].N<>0 then begin

  resu:=nil;   //  
  prevX:=obj[i].mas[0].X;
  prevY:=obj[i].mas[0].Y;
  j:=0;
  repeat
   inc(j); //      
  until (PS[prevY+sos8[j].Y,prevX+sos8[j].X].R<128)or(j=5); // j=5   - 1 
  if j<>5 then begin
   curX:=prevX+sos8[j].X;
   curY:=prevY+sos8[j].Y;
  end else continue;
  setlength(resu,1);
  resu[0].X:=curX; //      !
  resu[0].Y:=curY;
  PS[curY,curX].G:=255;
  PS[prevY,prevX].G:=255;
  repeat begin
   j:=j+5;
   if j>7 then j:=j-8;
   while PS[curY+sos8[j].Y,curX+sos8[j].X].R>128 do begin inc(j); if j=8 then j:=0; end;
   curX:=curX+sos8[j].X;
   curY:=curY+sos8[j].Y;
   setlength(resu,length(resu)+1);
   resu[high(resu)].X:=curX;  //        
   resu[high(resu)].Y:=curY;
   PS[curY,curX].G:=255;
  end until ((curX=prevX)and(curY=prevY)and(PS[curY+1,curX].R<128))or
            ((curX=prevX)and(curY=prevY)and(PS[curY,curX+1].G>128)and(PS[curY+1,curX+1].G>128)); //             

  vec1:=nil;   //     1 (-), 2 (-), 3 (-), 4 (-)
  dx:=resu[high(resu)-1].X-resu[high(resu)].X;
  dy:=resu[high(resu)-1].Y-resu[high(resu)].Y;
  if (dx=1)and(dy=0) then   //   -        3-  
   ix:=1
  else if (dx=-1)and(dy=1) then
   ix:=3
  else ix:=4;   
  ix:=NextVeks(resu[high(resu)].Y,resu[high(resu)].X,resu[0].Y,resu[0].X,ix); // ( )      
  for j:=0 to high(resu)-1 do ix:=NextVeks(resu[j].Y,resu[j].X,resu[j+1].Y,resu[j+1].X,ix);
 
  setlength(vec,length(vec1)); //  
  c:=1;  //  ,  ,     
  for j:=0 to high(vec) do begin
   dx:=0;
   dy:=0;
   for k:=0 to c do begin
    n:=j+k;
    if n>high(vec1) then n:=n-length(vec1);
    case vec1[n] of
     1: dx:=dx-1;
     2: dy:=dy+1;
     3: dx:=dx+1;
     4: dy:=dy-1;
    end;
   end;
   vec[j].D:=sqrt(dx*dx+dy*dy);
   vec[j].ug:=point2ang(dx,dy,0,0,vec[j].D);
  end;

  best:=0;
  bestugol:=0;
  min:=1e20;
  setlength(media,length(vec));
  for p:=0 to 14 do begin
   for u:=1 to 120 do begin

    for j:=0 to high(vec) do begin //    
     vec[j].ug:=vec[j].ug+3;
     if vec[j].ug>=360 then vec[j].ug:=vec[j].ug-360;
    end;

    ex:=0; // 
    ey:=0;
    DYN:=0;
    DXL:=0;
    DXR:=0;
    miny:=0; // 
    minX:=0;
    l:=0; // 
    for j:=0 to high(vec) do begin
     de:=ang2point(vec[j].ug,vec[j].D);
     ex:=ex+de.dx;
     ey:=ey+de.dy;
     media[j].X:=ex; //        
     media[j].Y:=ey;
     if ey>DYN then DYN:=ey; //  
     if ex<DXL then DXL:=ex; //  
     if ex>DXR then DXR:=ex; //  
     if ey<miny then begin  //    
      miny:=ey;
      minx:=ex;
      l:=j;  // ,      
     end;
    end;
    for j:=0 to high(media) do
     if (abs(miny-media[j].Y)<0.1)and(media[j].X<minx) then begin
      minx:=media[j].X;
      miny:=media[j].Y;
      l:=j;  // ,     - 
     end;

    if (minx-dxl)<>0 then DXL:=Etalons[p][0]/(minx-dxl) else DXL:=0;
    if (minx-dxr)<>0 then DXR:=Etalons[p][1]/(minx-dxr) else DXR:=0;
    if (miny-dyn)<>0 then DYN:=Etalons[p][2]/(miny-dyn) else DYN:=0;
    for j:=0 to high(media) do begin  ///
     if media[j].X<minx then begin //    
      media[j].X:=minx-(minx-media[j].X)*DXL;
     end;
     if media[j].X>minx then begin //    
      media[j].X:=minx-(minx-media[j].X)*DXR;
     end;
     if media[j].y>miny then begin //    
      media[j].y:=miny-(miny-media[j].y)*DYN;
     end;
    end;      

    dlina:=0;      //   
    nx:=media[high(media)].X; //      
    ny:=media[high(media)].Y;
    for j:=0 to high(media) do begin
     ex:=media[j].X;
     ey:=media[j].Y;
     ddx:=nx-ex; //      
     ddy:=ny-ey;
     dlina:=dlina+sqrt(ddx*ddx+ddy*ddy);
     nx:=ex;
     ny:=ey;
    end;

    test[0].x:=minx; //   -
    test[0].y:=miny;
    nx:=minx; //        //    
    ny:=miny;
    inc(l);   //  ,      ,   
    if l>high(media) then l:=0;
    ex:=media[l].X; //      
    ey:=media[l].Y;
    ddx:=nx-ex; //      
    ddy:=ny-ey;
    D:=sqrt(ddx*ddx+ddy*ddy);  //  
    DV:=D;  //   
    dug:=dlina/length(test); //  
    DP:=0;   //       
    j:=0;
    repeat begin
     DP:=DP+dug;
     inc(j);
     while DV<DP do begin //  ,        
      inc(l);
      if l>high(media) then l:=0;
      nx:=ex; //     ,     
      ny:=ey;
      ex:=media[l].X; //    
      ey:=media[l].Y;
      ddx:=nx-ex; //      
      ddy:=ny-ey;
      D:=sqrt(ddx*ddx+ddy*ddy);
      DV:=DV+D;
     end;
     dlina:=(DV-DP)/D; //      
     test[j].x:=ex+ddx*dlina;
     test[j].y:=ey+ddy*dlina;
    end until j=high(test);

    d:=0; //     
    for j:=0 to high(test) do begin
     ddx:=test[j].X-test[0].X-Etalons[p][(j+2)*2];
     ddy:=test[j].Y-test[0].Y-Etalons[p][(j+2)*2+1];
     d:=d+sqrt(ddx*ddx+ddy*ddy);
    end;
    d:=d/Etalons[p][3]; //    
    if d<min then begin
     min:=d;
     best:=p;
     bestugol:=u*3;
    end;
    
   end;
  end;
  if best<>14 then obj[i].Re:=best else  //      9-6 
   if (bestugol>90)and(bestugol<270) then obj[i].Re:=15 else obj[i].Re:=14;

  ProgressBar1.StepIt;
 end;
 
 ProgressBar1.Position:=0;
 bitBlt(buf.Canvas.Handle,0,0,buf.Width,buf.Height,sour.Canvas.Handle,0,0,srccopy);
 for i:=1 to high(obj) do if obj[i].N<>0 then
  buf.Canvas.TextOut(obj[i].mas[0].x,obj[i].mas[0].Y-15,Alph[obj[i].Re]);
 Form1.FormPaint(nil);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
 if opendialog1.Execute then begin
  OpenPic(opendialog1.FileName);
  Opoznat;
 end;
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
 bitblt(form1.Canvas.Handle,globalX,globalY,buf.Width,buf.Height,buf.Canvas.Handle,0,0,srccopy);
end;

procedure TForm1.FormCreate(Sender: TObject);
 var i:integer;
begin
 sour:=tbitmap.Create;
 buf:=tbitmap.Create;
 sour.PixelFormat:=pf24bit;
 buf.PixelFormat:=pf24bit;
 doublebuffered:=true;
 globalX:=GX;
 globalY:=GY;
 sour.Width:=700;
 sour.Height:=500;
 PS:=nil;
 setlength(PS,sour.Height);
 for i:=0 to High(PS) do PS[i]:=sour.scanline[i];
 buf.Width:=sour.Width;
 buf.Height:=sour.Height;
 buf.Canvas.Font.Color:=clred;
 form1.Paint;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 sour.Free;
 buf.Free;
end;

procedure TForm1.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 if Button=mbRight then begin
  trig:=true;
  prevx:=x;
  prevy:=y;
 end else begin
  drawtrig:=true;
  prevdx:=x-globalx;
  prevdy:=y-globalY;
  sour.Canvas.Pen.Width:=5;
  sour.Canvas.Pen.Color:=clblack;
  sour.Canvas.MoveTo(prevdx,prevdy);
 end;
end;

procedure TForm1.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 if Button=mbRight then begin
  trig:=false;
 end;
 drawtrig:=false;
end;

procedure TForm1.FormMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
begin
 if trig then begin
  globalx:=globalx-(prevx-x);
  globaly:=globaly-(prevy-y);
  prevx:=x;
  prevy:=y;
  form1.Repaint;
 end;
 if drawtrig then begin
  sour.Canvas.MoveTo(prevdx,prevdy);
  sour.Canvas.LineTo(x-globalx,y-globaly);
  prevdx:=x-globalx;
  prevdy:=y-globaly;
  bitBlt(buf.Canvas.Handle,0,0,buf.Width,buf.Height,sour.Canvas.Handle,0,0,srccopy);
  form1.Repaint;
 end; 
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
 Opoznat;
end;

procedure TForm1.Button3Click(Sender: TObject);
 var R:trect;
begin
 r:=sour.Canvas.ClipRect;
 sour.Canvas.FillRect(R);
 bitBlt(buf.Canvas.Handle,0,0,buf.Width,buf.Height,sour.Canvas.Handle,0,0,srccopy);
 form1.Repaint; 
end;

end.
